import dsc40graph
from dataclasses import dataclass
@dataclass
class counter:
    max: int

def biggest_descendent(graph, root, value):
    def dfs(graph, u, max, status=None):
        """Start a DFS at `u`."""
        # initialize status if it was not passed
        if status is None:
            status = {node: 'undiscovered' for node in graph.nodes}
            
        status[u] = 'pending'
            
        for v in graph.neighbors(u): # explore edge (u, v)
            if status[v] == 'undiscovered':
                if max.max < value[v]:
                    max.max = value[v]
                dfs(graph, v, max, status)
        status[u] = 'visited'
  
    d = {}    
    # Get the roots max
    max = counter(max = 0)
    dfs(graph, root, max)
    d[root] = max.max
    
    def traverse(curr, d):
        """Function to traverse graph from given root

        Args:
            curr (Node): Current node to traverse from
            d (dict): Dictionary to store information
        """
        for node in graph.successors(curr):
            if len(graph.neighbors(node)) == 0:
                max = counter(max = 0)
                max.max = value[node]
                d[node] = max.max
                if len(graph.successors(node)) != 0:
                    traverse(node, d)
            else:
                max = counter(max = 0)
                dfs(graph, node, max)
                d[node] = max.max
                if len(graph.successors(node)) != 0:
                    traverse(node, d)
        
            
    traverse(root, d)
    return d


